
#pragma once

#include <string>

#include <CL/cl.h>

#include "Thread.h"

class CLSink;
class CLSource;
class GLWindow;


class CLCopyApp
{
public:

    CLCopyApp();
    ~CLCopyApp();

    bool    init(unsigned int uiWidth, unsigned int uiHeight, const char* cClassName);
    bool    start();
    void    stop();
    void    resize(unsigned int uiWidth, unsigned uiHeight);

    bool    isRunning() { return m_bRunning; };

private:

    static DWORD CALLAPI    SourceThreadFunc(void* pArg);
    static DWORD CALLAPI    SinkThreadFunc(void* pArg);

    bool                    SourceLoop();
    bool                    SinkLoop();

    void                    setupGL();
    bool                    setupCL();
	
	void                    processEvents(GLWindow *pWin);

    bool                    m_bRunning;
    bool                    m_bStarted;
    bool                    m_bNeedResize;

    unsigned int            m_uiWindowWidth;
    unsigned int            m_uiWindowHeight;

    unsigned int            m_uiFrameWidth;
    unsigned int            m_uiFrameHeight;

    unsigned int            m_uiQuad;

    CLSink*                 m_pSink;
    CLSource*               m_pSource;

    cl_context              m_pclCtx[2];
    cl_command_queue        m_pclCmdQueue[2];
    cl_device_id            m_pclDevId[2];

    GLWindow*               m_pWindow;

    Thread                  m_SourceThread;
    Thread                  m_SinkThread;

    Semaphore               m_SinkReady;
    Semaphore               m_SourceReady;
    Semaphore               m_SourceDone;
};
