#pragma once


#include <CL/cl.h>

#include "defines.h"

class SyncedBuffer;
class CLTransferBuffer;


class CLSink
{
public:
    
    CLSink(cl_context clCtx, cl_command_queue clCmdQueue);
    ~CLSink();

    bool            createStream(unsigned int uiNumBuffers, unsigned int w, unsigned int h);

    void            processFrame();

    void            release();

    unsigned long long  getBufferBusAddress(unsigned int uiId);
    unsigned long long  getMarkerBusAddress(unsigned int uiId);
    
    SyncedBuffer*   getInputQueue() { return m_pInputQueue; };
    
    unsigned int    getTexture()    { return m_glTexture; };

private:

    cl_context                          m_clCtx;
    cl_command_queue                    m_clCmdQueue;

    unsigned int                        m_uiQuad;
    unsigned int                        m_glTexture;

    cl_mem                              m_clImage;

    unsigned int                        m_uiBufferSize;
    unsigned int                        m_uiFrameWidth;
    unsigned int                        m_uiFrameHeight;

    CLTransferBuffer*                   m_pInputBuffer;
    SyncedBuffer*                       m_pInputQueue;
    FrameData*                          m_pFrameData;
};
