
#pragma once


#include <CL/cl.h>


class CLTransferBuffers;


class CLSource 
{
public:

    CLSource(cl_context clCtx, cl_command_queue clCmdQueue);
    ~CLSource();

    bool            createStream(unsigned int uiNumBuffers, unsigned int uiFrameWidth, unsigned int uiFrameHeight);
    bool            setRemoteMemory(unsigned int uiNumBuffers, unsigned long long* pBufferBusAddress, unsigned long long* pMarkerBusAddress);

    void            processFrame();

    void            release();
    void            setOutputQueue(SyncedBuffer* pOutputQueue);

private:

    bool            setupKernel();
    void            createCheckerboard();

    cl_context                          m_clCtx;
    cl_command_queue                    m_clCmdQueue;
    cl_device_id                        m_clDevId;
    cl_program                          m_clProgram;
    cl_kernel                           m_clKernel;
   
    cl_mem                              m_pclSourceBuffer[2];
    cl_mem                              m_clProcessedBuffer;

    unsigned int                        m_uiSourceBufferId;

    unsigned int                        m_uiBufferSize;
    unsigned int                        m_uiNumBuffers;
    unsigned int                        m_uiFrameWidth;
    unsigned int                        m_uiFrameHeight;
    unsigned int                        m_uiFrameCount;


    CLTransferBuffer*                   m_pOutputBuffer;
    SyncedBuffer*                       m_pOutputQueue;

    char*                               m_pData;
};