
#pragma once

class CLTransferBuffer
{
public:
    CLTransferBuffer(cl_context clCtx, cl_command_queue clQueue);
    ~CLTransferBuffer();

    bool createBuffers(unsigned int uiNumBuffers, unsigned int uiBufferSize, bool bLocal = true);
    bool assignRemoteMemory(unsigned int uiBufferId, cl_ulong ulSurfaceAddr, cl_ulong ulMarkerAddr);

    void waitMarker(unsigned int   uiBufferId, unsigned int uiMarkerValue);
    void writeMarker(unsigned int  uiBufferId, unsigned int uiMarkerValue);
    void writeMarker(unsigned long long ulRemoteAddress, unsigned int uiMarkerValue);

    cl_mem                  getBuffer(unsigned int uiIdx);
    cl_bus_address_amd*     getBufferBusAddress(unsigned int uiIdx);

    unsigned int            getNumBuffers()                { return m_uiNumBuffers; };

private:

    bool                    m_bBufferReady;
    bool                    m_bLocalMemory;
  
    unsigned int            m_uiNumBuffers;
    unsigned int            m_uiBufferSize;
    unsigned int            m_uiBufferIdx;
    
    cl_context              m_clCtx;
    cl_command_queue        m_clCmdQueue;
    cl_device_id            m_clDevId;
    cl_mem*                 m_pBuffer;
    cl_bus_address_amd*     m_pBusAddresses;
    cl_ulong*               m_pMarkerOffsets;
};
