

__kernel void copyImage(__global uchar *rgbaIn, __global uchar *rgbaOut, int2 vShift, int2 vDim)
{
    uint uiGlobalId_X = get_global_id(0);
    uint uiGlobalId_Y = get_global_id(1);

    uint uiBufferOffset = (uiGlobalId_X + (uiGlobalId_Y * vDim.x )) * 4;
    uint uiSourceOffset = (((uiGlobalId_X + vShift.x) % vDim.x) +  (((uiGlobalId_Y + vShift.y) % vDim.y) * vDim.x )) * 4;
    
    rgbaOut[uiBufferOffset]     = rgbaIn[uiSourceOffset];
    rgbaOut[uiBufferOffset + 1] = rgbaIn[uiSourceOffset + 1];
    rgbaOut[uiBufferOffset + 2] = rgbaIn[uiSourceOffset + 2];
    rgbaOut[uiBufferOffset + 3] = rgbaIn[uiSourceOffset + 3];
}

