
#pragma once

#include <string>

#include "GLWindow.h"
#include "Thread.h"

class GLSink;
class GLSource;
class GLWindow;



class GLCopyApp
{
public:

    GLCopyApp();
    virtual ~GLCopyApp();

    bool    init(unsigned int uiWidth, unsigned int uiHeight, const char* pClassName=NULL);
    bool    start(bool bUseP2P);
    void    stop();
	
    bool    isRunning() { return m_bRunning; };

private:

    static DWORD CALLAPI    SourceThreadFunc(void* pArg);
    static DWORD CALLAPI    SinkThreadFunc(void* pArg);

    bool    SourceLoop();
    bool    SinkLoop();

    void    processEvents(GLWindow* pWin);
    
    bool                m_bRunning;                 // Indicates that the thread is running
    bool                m_bStarted;                 // Indicates that the thread was started
    bool                m_bResizeSource;            // if true, the source window was resized
    bool                m_bResizeSink;              // if true, the sink window was resized

    bool                m_bUseP2P;
    bool                m_bCanDoP2P;

    unsigned int        m_uiBufferWidth;
    unsigned int        m_uiBufferHeight;

    GLWindow*           m_pSourceWin;
    GLWindow*           m_pSinkWin;

    GLSink*             m_pSink;                  // OpenGL consumer of frames rendered by GLSource
    GLSource*           m_pSource;                // OpenGL producer produces frames for GLSink

    Thread              m_SourceThread;
    Thread              m_SinkThread;

    Semaphore           m_SinkReady;
    Semaphore           m_SourceReady;
    Semaphore           m_SourceDone;

    std::string         m_strErrorMessage;
};
