

#pragma once

#include "GLTransferBuffers.h" 

class SyncedBuffer;
class RenderTarget;


class GLSource
{
public:

    GLSource();
    ~GLSource();

    void            initGL();
    void            resize(unsigned int w, unsigned int h);
    bool            createUpStream(unsigned int w, unsigned int h, int nIntFormat, int nExtFormat, int nType, bool bUseP2P, AlignedMem* pMem = NULL);

    bool            setRemoteMemory(unsigned long long* pBufferBusAddress, unsigned long long* pMarkerBusAddress);

    void            draw();

    void            release();

    void            setSyncBuffer(SyncedBuffer* pSyncBuffer);
    SyncedBuffer*   getSyncBuffer() { return m_pSyncBuffer; };

private:

    bool                    m_bUseP2P;

    unsigned int            m_uiWindowWidth;
    unsigned int            m_uiWindowHeight;

    unsigned int            m_uiBufferWidth;
    unsigned int            m_uiBufferHeight;

    int                     m_nIntFormat;
    int                     m_nExtFormat;
    int                     m_nType;

    unsigned int            m_uiCube;

    float                   m_fRotationAngle;

    RenderTarget*           m_pRenderTarget[NUM_BUFFERS];
    GLTransferBuffers*      m_pOutputBuffer;
    SyncedBuffer*           m_pSyncBuffer;
};
