#include "os_include.h"
#include <string>

#include <GL/glew.h>
#include "GLCopyApp.h"


// Size of the frames
unsigned int g_uiWidth  = 1280;
unsigned int g_uiHeight =  720;


LRESULT CALLBACK    WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);


using namespace std;

  

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
    WNDCLASSEX      wndclass;
    const LPCSTR    cClassName  = "OGL";
    const LPCSTR    cWindowName = "GPU P2P Copy";

    // Register WindowClass
    wndclass.cbSize         = sizeof(WNDCLASSEX);
    wndclass.style          = CS_OWNDC;
    wndclass.lpfnWndProc    = WndProc;
    wndclass.cbClsExtra     = 0;
    wndclass.cbWndExtra     = 0;
    wndclass.hInstance      = (HINSTANCE)GetModuleHandle(NULL);
    wndclass.hIcon          = LoadIcon(NULL, IDI_APPLICATION); 
    wndclass.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground  = NULL;
    wndclass.lpszMenuName   = NULL;
    wndclass.lpszClassName  = cClassName;
    wndclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

    if (!RegisterClassEx(&wndclass))
        return WM_QUIT;

    GLCopyApp* pApp = new GLCopyApp;

    if (!pApp->init(g_uiWidth, g_uiHeight, cClassName))
    {
        return WM_QUIT;
    }

    if (pApp->start(true))
    {
        // Run message loop
        MSG	    Msg;

        bool bDone = !pApp->isRunning();

        while (!bDone)
        {
            bDone = !pApp->isRunning();

            if (PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE))
			{
				if (Msg.message == WM_QUIT)
				{
					bDone = true;
				}
				else
				{
					TranslateMessage(&Msg);
					DispatchMessage(&Msg);
				}
			}
            Sleep(100);
        }

        pApp->stop();
    }

    delete pApp;

    return WM_QUIT;
}



LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static int nLastx = 0;
    static int nLasty = 0;

    switch (uMsg)
    {
        char c;

        case WM_CHAR:
            c = (char)wParam;

            switch (c)
            {
            case VK_ESCAPE:
                PostQuitMessage(0);
		        break;
            }
            return 0;

        case WM_CREATE:
            return 0;

        case WM_SIZE:
            return 0;

        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
    }

    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

